package com.rouf69nb.android_broadcaster

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.util.Log
import android.widget.Toast
import io.flutter.embedding.engine.FlutterEngine
import io.flutter.embedding.engine.dart.DartExecutor
import io.flutter.plugin.common.MethodChannel
import io.flutter.view.FlutterCallbackInformation
import io.flutter.view.FlutterMain

class RemoteBroadcastReceiver : BroadcastReceiver(){
    override fun onReceive(context: Context, intent: Intent?) {

        FlutterMain.startInitialization(context)
        FlutterMain.ensureInitializationComplete(context, arrayOf())

        val handle = Helper.getRawHandle(context)
        if (handle == Helper.NO_HANDLE) {
            Log.w("RemoteBroadcastReceiver", "Couldn't update widget because there is no handle stored!")
            return
        }

        val callbackInfo = FlutterCallbackInformation.lookupCallbackInformation(handle)
        // You could also use a hard coded value to save you from all
        // the hassle with SharedPreferences, but alas when running your
        // app in release mode this would fail.
        val entryPointFunctionName = callbackInfo.callbackName

        // Instantiate a FlutterEngine.
        val engine = FlutterEngine(context.applicationContext)
        val entryPoint = DartExecutor.DartEntrypoint(FlutterMain.findAppBundlePath(), entryPointFunctionName)
        engine.dartExecutor.executeDartEntrypoint(entryPoint)

        // Register Plugins when in background. When there
        // is already an engine running, this will be ignored (although there will be some
        // warnings in the log).
//        GeneratedPluginRegistrant.registerWith(engine)

        MethodChannel(engine.dartExecutor.binaryMessenger, Helper.CHANNEL).invokeMethod("onReceived",intent?.extras?.get("data"))
    }
}